local mod = ...



-- ************************************************************************************************
-- Component: Controller --------------------------------------------------------------------------
-- ************************************************************************************************

-- Component
local COMP_DRAGON_CONTROLLER = {
	TypeName = "COMP_DRAGON_CONTROLLER",
	ParentType = "COMPONENT",
	Properties = {
    }
}


-- onEnabled
function COMP_DRAGON_CONTROLLER:onEnabled()


    -- set up daily event
    local compMainGameLoop = self:getLevel():find("COMP_MAIN_GAME_LOOP")
    event.register(self, compMainGameLoop.ON_NEW_DAY, function()

        -- Count the current dragons
        local countDragon = 0
        self:getLevel():getComponentManager("COMP_DRAGON"):getAllComponent():forEach(function(compDragon)
            countDragon = countDragon + 1
        end)

        -- Count the current population
        local countVillager = 0
        self:getLevel():getComponentManager("COMP_VILLAGER"):getAllComponent():forEach(function(compVillager)
            countVillager = countVillager + 1
        end)

        -- Create a new dragon
        local chance = math.random()
        if countDragon < 1 and chance <= (1/200) and countVillager >= 50 then

            local posCorner = {124, 0, 124}
            local randCorner = math.random(1, 4)

            if randCorner == 1 then
                posCorner = {124, 0, 124}

            elseif randCorner == 2 then
                posCorner = {124, 0, 900}

            elseif randCorner == 3 then
                posCorner = {900, 0, 900}

            elseif randCorner == 4 then
                posCorner = {900, 0, 124}

            end

            local indexDragon = math.random(1, 1)
            self:getLevel():createObject("PREFAB_DRAGON_DRAGON" .. indexDragon, posCorner)
            mod:log("Dragon spawned at " .. tostring(posCorner))


            -- Notification
            local compVillager = self:getLevel():getComponentManager("COMP_VILLAGER"):getFirstEnabled()
            local jobAsset = nil
            local jobWorkplace = nil
            if (compVillager) then

                local job = compVillager:getJobInstance()
                if (job) then
                    jobAsset = job.AssetJob
                    jobWorkplace = job.Workplace
                end

                compVillager:changeJob("JOB_DRAGON_EVENT_START")

                if (job) then
                    if (jobWorkplace) then
                        compVillager:changeJob(jobAsset, jobWorkplace)
                    else
                        compVillager:changeJob(jobAsset)
                    end
                else
                    compVillager:changeJob(nil)
                end

            end -- Villager found to trigger the notification


        end

    end)


end


-- Register
mod:registerClass(COMP_DRAGON_CONTROLLER)


-- Attach component
mod:registerPrefabComponent("PREFAB_MANAGER", { DataType = "COMP_DRAGON_CONTROLLER" } )


